## s390-tools 2.41.0

=== Makefile ===
# Include common definitions
include common.mak

#
# BASELIBS: Libraries that have no dependency to other libraries in s390-tools
# LIBS: Libraries that can have a dependency to base libraries
# TOOLS: Tools that can have a dependency to base libraries or libraries
#
ifeq ($(HOST_ARCH),s390x)
BASELIB_DIRS = libutil libseckey
LIB_DIRS = libvtoc libzds libdasd libccw libvmcp libekmfweb \
	   libkmipclient libcpumf libap libpv libzpci
TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
	   vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl \
	   lsstp hsci hsavmcore chreipl-fcp-mpath ap_tools rust opticsmon \
	   zpwr zmemtopo

else
BASELIB_DIRS =
LIB_DIRS = libpv
TOOL_DIRS = netboot rust
endif

SUB_DIRS = $(BASELIB_DIRS) $(LIB_DIRS) $(TOOL_DIRS)

all: $(TOOL_DIRS)
clean: $(TOOL_DIRS)
install: $(TOOL_DIRS)

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

#
# We have to build the base libraries before the other libraries are built,
# and then build the other libraries before the tools are built. Otherwise the
# other libraries and tools would trigger parallel "make -C" builds for the
# base libraries and the other libraries in case of "make -j".
#
# MAKECMDGOALS contains the list of goals, e.g. "clean all". We use
# "foreach" to generate a ";" separated list of "make -C <target>".
# For example the the expansion for "make clean all" is:
#
# $(MAKE) -C $@ [..] clean ;  $(MAKE) -C $@ [...] all ;
#
# This ensures that the commandline targets are serialized and also "make -j"
# works as expected, e.g. "make clean all -j 20".
#

$(TOOL_DIRS): $(LIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(TOOL_DIRS)

$(LIB_DIRS): $(BASELIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(LIB_DIRS)

$(BASELIB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(BASELIB_DIRS)

=== cpacfstats/Makefile ===
include ../common.mak

ifeq (${HAVE_LIBUDEV},0)

all:
	$(SKIP) HAVE_LIBUDEV=0

install:
	$(SKIP) HAVE_LIBUDEV=0

else

check_dep:
	$(call check_dep, \
		"cpacfstatsd", \
		"libudev.h", \
		"systemd-devel", \
		"HAVE_LIBUDEV=0")

ALL_CPPFLAGS += -DVERSION=$(VERSION)

all:		check_dep cpacfstats cpacfstatsd

cpacfstatsd:	cpacfstatsd.o stats_sock.o perf_crypto.o cpacfstats_common.o \
			$(rootdir)/libcpumf/libcpumf.a $(rootdir)/libutil/libutil.a
		$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -ludev -lpthread -o $@

cpacfstats:	cpacfstats.o stats_sock.o cpacfstats_common.o
		$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

install: 	all
		$(INSTALL) -m 755 cpacfstatsd   $(DESTDIR)$(USRSBINDIR)
		$(INSTALL) -m 755 cpacfstats    $(DESTDIR)$(USRBINDIR)
		$(INSTALL) -m 644 cpacfstatsd.8 $(DESTDIR)$(MANDIR)/man8
		$(INSTALL) -m 644 cpacfstats.1  $(DESTDIR)$(MANDIR)/man1

endif

clean:
		rm -f *.o *~ cpacfstatsd cpacfstats

.PHONY: all clean install check_dep

=== zkey/Makefile ===
include ../common.mak

ifneq (${HAVE_OPENSSL},0)
	ifneq (${HAVE_CRYPTSETUP2},0)
		BUILD_TARGETS += zkey
		INSTALL_TARGETS += install-zkey
		ifneq (${HAVE_JSONC},0)
			ifneq (${HAVE_LIBCURL},0)
				SUB_DIRS += ekmfweb
				ifneq (${HAVE_LIBXML2},0)
					SUB_DIRS += kmip
				endif
			endif
		endif
	else
		BUILD_TARGETS += zkey-skip-cryptsetup2
		INSTALL_TARGETS += zkey-skip-cryptsetup2
	endif
else
	BUILD_TARGETS += zkey-skip-openssl
	INSTALL_TARGETS += zkey-skip-openssl
endif

ifneq (${HAVE_CRYPTSETUP2},0)
	ifneq (${HAVE_JSONC},0)
		ifneq (${HAVE_OPENSSL},0)
			BUILD_TARGETS += zkey-cryptsetup
			INSTALL_TARGETS += install-zkey-cryptsetup
		else
			BUILD_TARGETS += zkey-cryptsetup-skip-openssl
			INSTALL_TARGETS += zkey-cryptsetup-skip-openssl
		endif
	else
		BUILD_TARGETS += zkey-cryptsetup-skip-jsonc
		INSTALL_TARGETS += zkey-cryptsetup-skip-jsonc
	endif
else
	BUILD_TARGETS += zkey-cryptsetup-skip-cryptsetup2
	INSTALL_TARGETS += zkey-cryptsetup-skip-cryptsetup2
endif

libs = $(rootdir)/libutil/libutil.a

ALL_CFLAGS += -DKMS_PLUGIN_LOCATION=\"$(ZKEYKMSPLUGINDIR)\" \
	-D_FILE_OFFSET_BITS=64

detect-libcryptsetup.dep:
	echo "#include <libcryptsetup.h>" > detect-libcryptsetup.dep
	echo "#ifndef CRYPT_REQUIREMENT_INLINE_HW_TAGS" >> detect-libcryptsetup.dep
	echo "  #error libcryptsetup version 2.8.2 is required" >> detect-libcryptsetup.dep
	echo "#endif" >> detect-libcryptsetup.dep
	echo "int i = CRYPT_SLOT_UNBOUND;" >> detect-libcryptsetup.dep
	echo "int test(void) { return crypt_reencrypt_init_by_keyslot_context(NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL); }" >> detect-libcryptsetup.dep

check-dep-zkey: detect-libcryptsetup.dep
	$(call check_dep, \
		"zkey", \
		"openssl/evp.h", \
		"openssl-devel", \
		"HAVE_OPENSSL=0")
	$(call check_dep, \
		"zkey", \
		"detect-libcryptsetup.dep", \
		"cryptsetup-devel version 2.8.2", \
		"HAVE_CRYPTSETUP2=0", \
		-I. -lcryptsetup)
	touch check-dep-zkey

check-dep-zkey-cryptsetup: detect-libcryptsetup.dep
	$(call check_dep, \
		"zkey-cryptsetup", \
		"detect-libcryptsetup.dep", \
		"cryptsetup-devel version 2.8.2", \
		"HAVE_CRYPTSETUP2=0", \
		-I. -lcryptsetup)
	$(call check_dep, \
		"zkey-cryptsetup", \
		"json-c/json.h", \
		"json-c-devel", \
		"HAVE_JSONC=0")
	touch check-dep-zkey-cryptsetup

zkey-skip-openssl:
	echo "  SKIP    zkey due to HAVE_OPENSSL=0"

zkey-skip-cryptsetup2:
	echo "  SKIP    zkey due to HAVE_CRYPTSETUP2=0"

zkey-cryptsetup-skip-cryptsetup2:
	echo "  SKIP    zkey-cryptsetup due to HAVE_CRYPTSETUP2=0"

zkey-cryptsetup-skip-jsonc:
	echo "  SKIP    zkey-cryptsetup due to HAVE_JSONC=0"

zkey-cryptsetup-skip-openssl:
	echo "  SKIP    zkey-cryptsetup due to HAVE_OPENSSL=0"

all: $(BUILD_TARGETS) $(SUB_DIRS)

zkey.o: check-dep-zkey zkey.c pkey.h cca.h ep11.h misc.h
pkey.o: pkey.c pkey.h cca.h ep11.h utils.h
cca.o: cca.c cca.h pkey.h ep11.h utils.h
ep11.o: ep11.c ep11.h pkey.h cca.h utils.h
utils.o: utils.h pkey.h cca.h ep11.h
properties.o: check-dep-zkey properties.c properties.h
keystore.o: check-dep-zkey keystore.c keystore.h properties.h pkey.h cca.h \
			ep11.h utils.h
zkey-cryptsetup.o: check-dep-zkey-cryptsetup zkey-cryptsetup.c pkey.h cca.h \
			ep11.h misc.h utils.h
kms.o: kms.c kms.h kms-plugin.h utils.h pkey.h
pvsecrets.o: pvsecrets.h

zkey: LDLIBS = -ldl -lcrypto
zkey: zkey.o pkey.o cca.o ep11.o properties.o keystore.o utils.o kms.o \
			pvsecrets.o $(libs)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

zkey-cryptsetup: LDLIBS = -ldl -lcryptsetup -ljson-c -lcrypto
zkey-cryptsetup: zkey-cryptsetup.o pkey.o cca.o ep11.o utils.o $(libs)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

install-common:
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1
	$(MAKE) -C initramfs install
	$(MAKE) -C dracut install

install-zkey: zkey
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zkey $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -m 644 -c zkey.1 $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -d -m 770 $(DESTDIR)$(SYSCONFDIR)/zkey
	$(INSTALL) -d -m 770 $(DESTDIR)$(SYSCONFDIR)/zkey/repository
	$(INSTALL) -m 644 -c kms-plugins.conf $(DESTDIR)$(SYSCONFDIR)/zkey

install-zkey-cryptsetup: zkey-cryptsetup
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zkey-cryptsetup $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -m 644 -c zkey-cryptsetup.1 $(DESTDIR)$(MANDIR)/man1

install: install-common $(INSTALL_TARGETS) $(SUB_DIRS)

clean: $(SUB_DIRS)
	rm -f *.o zkey zkey-cryptsetup detect-libcryptsetup.dep \
		check-dep-zkey check-dep-zkey-cryptsetup

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

$(SUB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(SUB_DIRS)

.PHONY: all install clean zkey-skip-cryptsetup2 zkey-skip-openssl \
	zkey-cryptsetup-skip-cryptsetup2 zkey-cryptsetup-skip-jsonc \
	install-common install-zkey install-zkey-cryptsetup

=== debian/changelog ===
s390-tools (2.41.0-0ubuntu1) resolute; urgency=medium

  * New upstream release. (LP: #2141945)
    - Refresh d/p/fix-64bit-lib-path-handling.patch to solve fuzz.
    - Update XS-Vendored-Sources-Rust field in d/control with new/different
      crates/versions.

 -- Frank Heimes <frank.heimes@canonical.com>  Mon, 16 Feb 2026 20:44:25 +0100

s390-tools (2.40.0-0ubuntu1) resolute; urgency=medium

  * New upstream release. (LP: #2135126)
    - d/control: bumped Standards-Version field to latest version to 4.7.2.
    - d/p/sg3-utils.patch: changed Forward field to not-needed
    - d/s390-tools.install*: expand to incl. pvverify tool and several
      bash and zsh completion files
    - d/s390-tools.install: add netboot related files to non-s390x packages,
      since they now work cross-platform

 -- Frank Heimes <frank.heimes@canonical.com>  Mon, 12 Jan 2026 13:25:25 +0100

=== debian/control ===
Source: s390-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>
Build-Depends:
 bsdextrautils,
 cargo,
 debhelper-compat (= 13),
 dh-cargo-tools,
 dh-exec,
 libcryptsetup-dev,
 libcurl4-openssl-dev,
 libfuse3-dev,
 libglib2.0-dev,
 libjson-c-dev,
 liblockfile-dev,
 libncurses-dev,
 libnl-3-dev,
 libnl-genl-3-dev,
 libnl-route-3-dev,
 libpfm4-dev,
 libsnmp-dev,
 libssl-dev,
 libxml2-dev,
 libz-dev,
 pkgconf,
 quilt
Standards-Version: 4.7.2
Homepage: https://github.com/ibm-s390-linux/s390-tools
XS-Build-Indep-Architecture: s390x
XS-Vendored-Sources-Rust: aho-corasick@1.1.3, anstream@0.6.18, anstyle-parse@0.2.6, anstyle-query@1.1.2, anstyle-wincon@3.0.6, anstyle@1.0.10, anyhow@1.0.95, autocfg@1.4.0, base64@0.22.1, bit-set@0.8.0, bit-vec@0.8.0, bitflags@2.7.0, bitvec@1.0.1, byteorder@1.5.0, cc@1.2.9, cfg-if@1.0.0, chrono@0.4.43, clap@4.5.23, clap_builder@4.5.23, clap_complete@4.5.38, clap_derive@4.5.18, clap_lex@0.7.4, colorchoice@1.0.3, curl-sys@0.4.83+curl-8.15.0, curl@0.4.49, darling@0.20.10, darling_core@0.20.10, darling_macro@0.20.10, deku@0.18.1, deku_derive@0.18.1, enum_dispatch@0.3.13, equivalent@1.0.1, errno@0.3.10, fastrand@2.3.0, fnv@1.0.7, foreign-types-shared@0.1.1, foreign-types@0.3.2, funty@2.0.0, getrandom@0.2.16, getrandom@0.3.2, hashbrown@0.12.3, hashbrown@0.15.2, heck@0.5.0, ident_case@1.0.1, indexmap@1.9.3, indexmap@2.6.0, is_terminal_polyfill@1.70.1, itoa@1.0.6, lazy_static@1.5.0, libc@0.2.172, libz-sys@1.1.20, linux-raw-sys@0.4.15, log@0.4.25, memchr@2.7.4, no_std_io2@0.8.1, num-traits@0.2.19, once_cell@1.20.2, openssl-macros@0.1.1, openssl-probe@0.1.5, openssl-sys@0.9.109, openssl@0.10.73, pkg-config@0.3.31, ppv-lite86@0.2.21, proc-macro-crate@3.2.0, proc-macro2@1.0.95, proptest@1.6.0, quick-error@1.2.3, quote@1.0.40, r-efi@5.2.0, radium@0.7.0, rand@0.8.5, rand@0.9.1, rand_chacha@0.3.1, rand_chacha@0.9.0, rand_core@0.6.4, rand_core@0.9.3, rand_xorshift@0.3.0, regex-automata@0.4.9, regex-syntax@0.8.5, regex@1.11.1, rustix@0.38.43, rustversion@1.0.18, rusty-fork@0.3.0, ryu@1.0.13, schannel@0.1.27, serde@1.0.228, serde_core@1.0.228, serde_derive@1.0.228, serde_json@1.0.149, serde_test@1.0.177, serde_yaml@0.9.21, shlex@1.3.0, socket2@0.6.0, strsim@0.11.1, syn@2.0.101, tap@1.0.1, tempfile@3.15.0, terminal_size@0.4.0, thiserror-impl@2.0.11, thiserror@2.0.11, toml_datetime@0.6.8, toml_edit@0.22.22, unarray@0.1.4, unicode-ident@1.0.18, unsafe-libyaml@0.2.11, utf8parse@0.2.2, vcpkg@0.2.15, wait-timeout@0.2.0, wasi@0.11.0+wasi-snapshot-preview1, wasi@0.14.2+wasi-0.2.4, winnow@0.6.20, wit-bindgen-rt@0.39.0, wyz@0.5.1, zerocopy-derive@0.8.25, zerocopy@0.8.25, zmij@1.0.21

Package: s390-tools
Architecture: s390x amd64 ppc64el arm64
Priority: important
Depends:
 gawk [s390x],
 s390-tools-data,
 udev [s390x],
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
 ${signing:Depends}
Recommends: sg3-utils [s390x]
Suggests:
 blktrace [s390x],
 lsscsi [s390x],
 mdevctl [s390x],
 multipath-tools [s390x],
 rsync [s390x],
 s390-tools-chreipl-fcp-mpath [s390x],
 s390-tools-cpuplugd [s390x],
 s390-tools-osasnmpd [s390x],
 s390-tools-statd [s390x]
Description: fundamental utilities for Linux on z Systems
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.
  * hsavmcore, which is used to make the dump process with kdump more
    efficient.
  * lshwc, which is used to extract and list complete counter sets

Package: s390-tools-cpuplugd
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: cpuplugd utility for Linux on z Systems
 The package contains cpuplugd hotplug daemon from the s390-tools
 collection of utilities.

Package: s390-tools-statd
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: s390-tools (<<1.34.0-0ubuntu7~)
Replaces: s390-tools (<<1.34.0-0ubuntu7~)
Description: mon_statd monitoring daemons for Linux on z Systems
 The package contains mon_procd and mon_fsstatd z/VM monitoring
 daemons for Linux on z Systems from the s390-tools collection of
 utilities. These tools are also known as mon_statd.

Package: s390-tools-osasnmpd
Architecture: s390x
Depends: udev, ${misc:Depends}, ${shlibs:Depends}
Description: osasnmpd utility for Linux on z Systems
 The package contains osasnmpd monitoring daemon from the s390-tools
 collection of utilities.

Package: s390-tools-zkey
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zkey utilities for Linux on z Systems
 The package contains zkey and zkey-cryptsetup from the s390-tools
 collection of utilities.

Package: libekmfweb1
Section: libs
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: integration with IBM Enterprise Key Management Foundation
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the runtime library.

Package: libekmfweb-dev
Section: libdevel
Architecture: s390x
Depends: ${misc:Depends}
Description: integration with IBM Enterprise Key Management Foundation (development)
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the development library and headers.

Package: libkmipclient1
Section: libs
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: KMIP client library
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the runtime library.

Package: libkmipclient-dev
Section: libdevel
Architecture: s390x
Depends: ${misc:Depends}
Description: KMIP client library (development)
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the development library and headers

Package: s390-tools-chreipl-fcp-mpath
Architecture: s390x
Depends: multipath-tools, multipath-tools-boot, udev, ${misc:Depends}
Description: chreipl-fcp-mpath utility for Linux on z Systems
 The package contains chreipl-fcp-mpath toolset from the s390-tools collection
 of utilities, that uses multipath information to change the configured FCP
 re-IPL path on detecting issues with the current path.

Package: s390-tools-data
Architecture: all
Depends: ${misc:Depends}
Replaces: s390-tools (<< 2.28.0-0ubuntu2)
Breaks: s390-tools (<< 2.28.0-0ubuntu2)
Description: fundamental utilities for Linux on z Systems (data files)
 Host architecture independent files used by s390-tools utilities for
 z Systems. Currently this package ships stage3a/b files for genprotimg.
